Rudiments: bytebuffer Class Reference

Rudiments

- Main Page
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
bytebuffer Class Reference

Inherited by stringbuffer.

## Public Member Functions
| bytebuffer ()
| bytebuffer (size_t initialsize, size_t increment)
| bytebuffer (unsigned char *initialcontents, size_t initialsize, size_t increment)
| bytebuffer (const bytebuffer &v)
bytebuffer & | operator= (const bytebuffer &v)
virtual | ~bytebuffer ()
void | setPosition (size_t pos)
size_t | getPosition ()
bytebuffer * | write (const unsigned char *data, size_t size)
bytebuffer * | write (const char *string)
bytebuffer * | write (const char *string, size_t size)
bytebuffer * | write (char character)
bytebuffer * | write (int16_t number)
bytebuffer * | write (int32_t number)
bytebuffer * | write (int64_t number)
bytebuffer * | write (unsigned char character)
bytebuffer * | write (uint16_t number)
bytebuffer * | write (uint32_t number)
bytebuffer * | write (uint64_t number)
bytebuffer * | write (float number)
bytebuffer * | write (double number)
bytebuffer * | writeFormatted (const char *format,...)
bytebuffer * | writeFormatted (const char *format, va_list *argp)
bytebuffer * | append (const unsigned char *data, size_t size)
bytebuffer * | append (const char *string)
bytebuffer * | append (const char *string, size_t size)
bytebuffer * | append (char character)
bytebuffer * | append (int16_t number)
bytebuffer * | append (int32_t number)
bytebuffer * | append (int64_t number)
bytebuffer * | append (unsigned char character)
bytebuffer * | append (uint16_t number)
bytebuffer * | append (uint32_t number)
bytebuffer * | append (uint64_t number)
bytebuffer * | append (float number)
bytebuffer * | append (double number)
bytebuffer * | appendFormatted (const char *format,...)
bytebuffer * | appendFormatted (const char *format, va_list *argp)
virtual void | truncate (size_t pos)
virtual void | truncate ()
ssize_t | read (unsigned char *data, size_t size)
void | clear ()
const unsigned char * | getBuffer ()
size_t | getSize ()
size_t | getEnd ()
size_t | getActualSize ()
unsigned char * | detachBuffer ()

## Detailed Description

The bytebuffer class can be used to store binary data of arbitrary length.

Internally, the class stores this data in a series of extents which are coalesced when getBuffer() or detachBuffer() are called. The size of the initial and incremental extents may be defined in the constructor.

When cleared, all extents except for the initial extent are freed.

It is generally more efficient to reuse the same bytebuffer over and over than to allocate a new one for each operation.

## Constructor & Destructor Documentation

bytebuffer::bytebuffer | ( |  | ) |

Creates an instance of the bytebuffer class with default initial size and increment parameters.

bytebuffer::bytebuffer | ( | size_t | initialsize,
|  | size_t | increment
| ) |  |

Creates an instance of the bytebuffer class with the specified "initialsize" and "increment" parameters.

bytebuffer::bytebuffer | ( | unsigned char * | initialcontents,
|  | size_t | initialsize,
|  | size_t | increment
| ) |  |

Creates an instance of the bytebuffer class. The buffer "initialcontents" will be attached to the instance and used as the initial contents. This buffer should not be freed by the calling program. The initial size and increment may be specified respectively by the "initialsize" and "increment" parameters.

bytebuffer::bytebuffer | ( | const bytebuffer & | v | ) |

Creates an instance of the bytebuffer class that is a copy of "v".

virtual bytebuffer::~bytebuffer | ( |  | ) |
| virtual

Deletes this instance of the bytebuffer class.

## Member Function Documentation

bytebuffer* bytebuffer::append | ( | const unsigned char * | data,
|  | size_t | size
| ) |  |

Appends the first "size" bytes of "data" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | const char * | string | ) |

Appends "string" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | const char * | string,
|  | size_t | size
| ) |  |

Appends the first "size" bytes of "string" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | char | character | ) |

Appends "character" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | int16_t | number | ) |

Appends "number" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | int32_t | number | ) |

Appends "number" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | int64_t | number | ) |

Appends "number" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | unsigned char | character | ) |

Appends "character" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | uint16_t | number | ) |

Appends "number" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | uint32_t | number | ) |

Appends "number" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | uint64_t | number | ) |

Appends "number" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | float | number | ) |

Appends "number" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::append | ( | double | number | ) |

Appends "number" to the bytebuffer, growing the internal buffer as necessary to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->append("numbers: ")->append(5)->append(5.5);

bytebuffer* bytebuffer::appendFormatted | ( | const char * | format,
|  |  | ...
| ) |  |

Appends "..." to the byte buffer using "format" which should comply with standard printf formatting rules.

bytebuffer* bytebuffer::appendFormatted | ( | const char * | format,
|  | va_list * | argp
| ) |  |

Appends "argp" to the byte buffer using "format" which should comply with standard printf formatting rules.

Note that argp is a pointer to a va_list, not just a va_list.

void bytebuffer::clear | ( |  | ) |

Empties the bytebuffer.

unsigned char* bytebuffer::detachBuffer | ( |  | ) |

Returns a pointer to the buffer currently stored in the bytebuffer, then resets the bytebuffer such that it will no longer use that buffer.

The calling program must deallocate the buffer returned from this method.

size_t bytebuffer::getActualSize | ( |  | ) |

Returns the actual size of the buffer which may be larger than the value returned by getSize() since the buffer grows in chunks.

const unsigned char* bytebuffer::getBuffer | ( |  | ) |

Returns the current data stored in the bytebuffer.

size_t bytebuffer::getEnd | ( |  | ) |

Returns the position in the buffer at which the next append will occur.

size_t bytebuffer::getPosition | ( |  | ) |

Returns the position in the buffer at which the next write will occur.

size_t bytebuffer::getSize | ( |  | ) |

Returns the amount of data currently stored in the bytebuffer.

bytebuffer& bytebuffer::operator= | ( | const bytebuffer & | v | ) |

Makes this instance of the bytebuffer class identical to "v".

ssize_t bytebuffer::read | ( | unsigned char * | data,
|  | size_t | size
| ) |  |

Reads "size" bytes from the bytebuffer at the current position into "data". Also increments the current position by "size" bytes.

void bytebuffer::setPosition | ( | size_t | pos | ) |

Sets the position in the internal buffer at which the next read or write will occur to "pos". If the position is set beyond the end of the buffer, the buffer will grow but the data between the current end of the buffer and the new position will be undefined.

virtual void bytebuffer::truncate | ( | size_t | pos | ) |
| virtual

Truncates the bytebuffer at position "pos".

Reimplemented in stringbuffer.

virtual void bytebuffer::truncate | ( |  | ) |
| virtual

Truncates the bytebuffer at the current position.

Reimplemented in stringbuffer.

bytebuffer* bytebuffer::write | ( | const unsigned char * | data,
|  | size_t | size
| ) |  |

Writes the first "size" bytes of "data" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | const char * | string | ) |

Writes "string" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | const char * | string,
|  | size_t | size
| ) |  |

Writes the first "size" bytes of "string" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | char | character | ) |

Writes "character" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | int16_t | number | ) |

Writes "number" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | int32_t | number | ) |

Writes "number" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | int64_t | number | ) |

Writes "number" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | unsigned char | character | ) |

Writes "character" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | uint16_t | number | ) |

Writes "number" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | uint32_t | number | ) |

Writes "number" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | uint64_t | number | ) |

Writes "number" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | float | number | ) |

Writes "number" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::write | ( | double | number | ) |

Writes "number" to the bytebuffer at the current position and increments the current position to the next byte after the data that was written. If necessary, the internal buffer will grow to accommodate the new data.

Returns a pointer to "this" to enable chaining such as: vb->write("numbers: ")->write(5)->write(5.5);

bytebuffer* bytebuffer::writeFormatted | ( | const char * | format,
|  |  | ...
| ) |  |

Writes "..." to the byte buffer using "format" which should comply with standard printf formatting rules.

bytebuffer* bytebuffer::writeFormatted | ( | const char * | format,
|  | va_list * | argp
| ) |  |

Writes "argp" to the byte buffer using "format" which should comply with standard printf formatting rules.

Note that argp is a pointer to a va_list, not just a va_list.